<!DOCTYPE html>
<html xmlns:th="http://www.w3.org/1999/xhtml" lang="en">
<head>
    <meta charset="UTF-8">
    <title>Splat Tree</title>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css"
          integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
    <link rel="stylesheet" th:href="@{/css/styles.css}">
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
</head>
<body>
<div id="root" class="container">
    <tree-menu :key="root.id" :root="root" :selected-id="selectedId">
    </tree-menu>
</div>
</body>

<script src="https://unpkg.com/axios/dist/axios.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.5.17/vue.min.js"></script>
<script type="text/x-template" id="tree-menu">
    <ul>
        <li @click.stop="toggleShowChildren" :id="root.id" draggable="true" @dragover.stop="allowDrop(event)"
            @dragstart.stop="dragStart(event)" @drop.stop="drop(event)">
            <i class="fas fa-circle-notch fa-xs" :class="loadingClasses"></i>
            <span class="node-label-wrapper" :class="selectedClass">
                <i class="fas" :class="iconClasses"></i>
                <input v-if="root.id === null" class="node-name-wrapper" @keyup.enter="createNode(event)"
                       @focusout.stop="$emit('node-deleted', null)" ref="newNodeNameInput"/>
                <input @click.stop @keyup.enter="saveName(event)" @focusout.stop="editable = false" v-else-if="editable"
                       type="text"
                       class="node-name-wrapper"/>
                <span v-else-if="!editable" class="node-name-wrapper">{{root.name}}</span>
                <template v-if="root.id !== null">
                    <i @click.stop="toggleEditable" v-if="allowEdit" class="fas fa-pen fa-xs"></i>
                    <i @click.stop="deleteNode" v-if="allowDelete" class="fas fa-trash fa-xs"></i>
                    <i @click.stop="createNodeButtonEventHandler" class="fas fa-plus-square fa-xs"></i>
                </template>
            </span>
            <template v-if="showChildren">
                <tree-menu
                        v-for="child in children"
                        :key="child.id"
                        :root="child"
                        :allow-delete="true"
                        :allow-edit="true"
                        :selected-id="selectedId"
                        @node-deleted="nodeDeletedEventHandler"
                ></tree-menu>
            </template>
        </li>
    </ul>
</script>
<script>
    Vue.component('tree-menu', {
        template: '#tree-menu',
        props: ['root', 'allowDelete', 'allowEdit', 'selectedId'],
        data() {
            return {
                showChildren: false,
                childrenLoaded: false,
                loading: false,
                editable: false,
                children: []
            }
        },
        mounted() {
            if (this.$refs["newNodeNameInput"]) {
                this.$refs["newNodeNameInput"].focus();
            }
        },
        computed: {
            iconClasses() {
                return {
                    'fa-folder': !this.showChildren,
                    'fa-folder-open': this.showChildren
                }
            },
            selectedClass() {
                return {
                    'selected': this.selected
                }
            },
            loadingClasses() {
                return {
                    'loading-off': !this.loading,
                    'fa-spin': this.loading
                }
            },
            color() {
                return this.selected ? 'red' : 'black';
            },
            selected() {
                return this.selectedId === this.root.id;
            }
        },
        methods: {
            toggleShowChildren() {
                if (this.root.id === null)
                    return;

                if (!this.selected) {
                    this.$root.$emit('node-selected', this.root.id);
                }
                this.showChildren = !this.showChildren;
            },
            toggleEditable() {
                this.editable = !this.editable;
            },
            saveName(event) {
                let newName = event.target.value;
                if (newName != null && newName.length !== 0) {
                    let vm = this;
                    axios.patch("/node", {
                        id: vm.root.id,
                        name: newName
                    }).then(function (response) {
                        vm.root.name = newName;
                    }).catch(function (error) {
                        alert(error.response.data.message);
                    });
                }
                this.toggleEditable();
            },
            deleteNode() {
                axios.delete("/node/" + this.root.id);
                this.$emit("node-deleted", this.root.id);
            },
            createNodeButtonEventHandler() {
                let vm = this;
                if (!this.showChildren) {
                    this.toggleShowChildren();
                }
                this.children.push({
                    id: null,
                    parentId: vm.root.id,
                    name: ""
                });
            },
            createNode(event) {
                let enteredName = event.target.value;
                if (enteredName === null || enteredName.length === 0) {
                    this.$emit('node-deleted', null);
                    return;
                }
                let vm = this;

                axios.post("/node", {
                    name: enteredName,
                    parentId: vm.$parent.root.id
                }).then(function (response) {
                    vm.root = response.data;
                    vm.$parent.children.push(vm.root);
                    vm.$parent.children.sort(function (a, b) {
                        if (a.name < b.name)
                            return -1;
                        if (a.name === b.name)
                            return 0;
                        if (a.name > b.name)
                            return 1;
                    });
                }).catch(function (error) {
                    alert(error.response.data.message);
                });
                vm.$emit('node-deleted', null);
            },
            nodeDeletedEventHandler(id) {
                for (let i = 0; i < this.children.length; i++) {
                    if (this.children[i].id === id)
                        Vue.delete(this.children, i);
                }
            },
            allowDrop(ev) {
                ev.preventDefault();
            },
            dragStart(ev) {
                console.log("Drag started, node name: " + this.root.name);
                ev.dataTransfer.dropEffect = "move";
                this.$root.$emit("drag-started", this);
            },
            drop(ev) {
                console.log("Drag ended, node name: " + this.root.name);
                this.$root.$emit("drag-ended", this);
            }
        },
        watch: {
            showChildren: function (newVal) {
                if (this.loading) {
                    return;
                }

                if (newVal && !this.childrenLoaded) {
                    let vm = this;
                    vm.loading = true;
                    axios.get("/node/" + vm.root.id + "/children").then(function (response) {
                        for (let el of response.data) {
                            vm.children.push(el);
                        }
                        vm.loading = false;
                        vm.childrenLoaded = true;
                    });
                }
            }
        }

    });

    let vm = new Vue({
        el: "#root",
        data: {
            root: {},
            selectedId: -1,
            dragSource: null,
            dragTarget: null,
        },
        created() {
            this.$on("node-selected", (selectedId) => this.selectedId = selectedId);
            this.$on("drag-started", (source) => {
                this.dragSource = source;
                console.log("Received drag-started event, node name: " + this.dragSource.root.name)
            });
            this.$on("drag-ended", this.dragEndedEventHandler);
        },
        mounted() {
            this.fetchRoot();
        },
        methods: {
            fetchRoot() {
                let vm = this;
                axios.get("/root")
                    .then(function (response) {
                        vm.root = response.data;

                    });
            },
            isDescendant(supposedAncestor, supposedDescendant) {
                if (supposedAncestor.$children.length === 0) {
                    return false;
                }
                if (supposedAncestor.$children[0].root.parentId === supposedDescendant.root.parentId) {
                    return true;
                }
                for (let child of supposedAncestor.$children) {
                    if (this.isDescendant(child, supposedDescendant)) {
                        return true;
                    }
                }
                return false;
            },
            dragEndedEventHandler(target) {
                this.dragTarget = target;

                if ((this.dragSource === this.dragTarget) ||
                    (this.dragSource == null || this.dragTarget == null) ||
                    (this.isDescendant(this.dragSource, this.dragTarget))) {

                    this.dragSource = null;
                    this.dragTarget = null;
                    return;
                }

                console.log("Received drag-ended event, node name: " + this.dragTarget.root.name);

                let vm = this;

                axios.patch("/node", {
                    id: vm.dragSource.root.id,
                    parentId: vm.dragTarget.root.id
                }).then(function (response) {
                    let node = vm.dragSource.root;
                    vm.dragSource.$emit("node-deleted", vm.dragSource.root.id);

                    node.parentId = vm.dragTarget.root.id;

                    if (vm.dragTarget.showChildren) {
                        vm.dragTarget.children.push(node);
                        vm.dragTarget.children.sort(function (a, b) {
                            if (a.name < b.name)
                                return -1;
                            if (a.name === b.name)
                                return 0;
                            if (a.name > b.name)
                                return 1;
                        });
                    }

                    this.dragSource = null;
                    this.dragTarget = null;
                }).catch(function (error) {
                    alert(error.response.data.message);

                    this.dragSource = null;
                    this.dragTarget = null;
                });
            }
        }
    })
</script>
</html>